//EckenEffekte_403d.js
// 07.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Rahmen mit runden oder abgeschrgten Ecken versehen (optionell: wlben).

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

// aktives Dokument notieren
var curDoc = app.documents[0];

// die Programmversion feststellen
var appVers = app.version[0];

// die Auswahl speichern und testen
var curSel = app.selection;
var nFrames = curSel.length;
if (nFrames == 0) {
	alert ("Es ist nichts ausgewhlt.", "Stop");
	exit();
}

// prfen, ob mindestens ein ausgewhltes Objekt in Ordnung ist, bevor der Dialog gezeigt wird
// gleichzeitig werden alle gezhlt, damit bei einem Problem die Meldung sofort (wenn 1 Objekt) 
// oder am Schluss (bei 2 Objekten oder mehr) gezeigt werden kann.
var cCtr = fCtr = pCtr = uCtr = 0;
for (var i=0; i<nFrames; i++) {
	var curItem = curSel[i];
	testGroupItems(curItem);
}

// die Funktion, welche eventuelle Gruppen "auseinandernimmt"
function testGroupItems(curFrame) {
	var curType = curFrame.constructor.name;
	if (curType == "Rectangle" || curType == "TextFrame" || curType == "Oval" || curType == "Polygon") {
		fCtr++;
	}
	else if (curType == "Group") {
		var allFrames = curFrame.allPageItems;
		for (var i=0; i< allFrames.length; i++) {
			var curFrame = allFrames[i];
			var curType = curFrame.constructor.name;
			if (curType != "Group") {
				testGroupItems(curFrame);
			}
		}
	}
}
if (fCtr == 0) {
	alert ("Einen Rechteck-Rahmen auswhlen\nund das Script nochmals starten.", "Achtung");
	exit();
}

// die Masseinheiten speichern
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
// wenn vertikal anders, dann wie horizontal einstellen
if (vM != hM) {
	curDoc.viewPreferences.verticalMeasurementUnits = hM;
}

// der Korrekturwert, um welchen die Radien verringert werden
// (zum Ausgleichen beim ganz leichten Wlben der Geraden
var corrVal = 0.92;
//var corrVal = 1;

// die aktuelle Masseinheit als String holen
var curUnit = unitsEnumToString(hM);

// auf "Millimeter" umstellen, wenn Einheit unbekannt
if (curUnit == "unbekannt") {
	curUnit = "in Millimetern";
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// den Handler aufrufen, welcher die gespeicherten Vorgaben einliest
var effectsDef = getPrefs();
// die vier Radien-Werte ausziehen
if (effectsDef != "") {
	var defVal = effectsDef.split("\n");
	var topL = defVal[0]*1;
	var topR = defVal[1]*1;
	var botL = defVal[2]*1;
	var botR = defVal[3]*1;
	var eType = defVal[4];
	if (eType == "0") {
		rType = true;
		iType = false;
		bType = false;
	}
	else if (eType == "1") {
		rType = false;
		iType = true;
		bType = false;
	}
	else if (eType == "2") {
		rType = false;
		iType = false;
		bType = true;
	}
	var camber  = defVal[5];
	if (camber == "true") {
		camb = true;
	}
	else {
		camb = false;
	}
}
else {
	var topL = 5;
	var topR = 5;
	var botL = 5;
	var botR = 5;
	var rType = true;
	var iType = false;
	var bType = false;
	var camb  = false;
}

// dem Anwender den Dialog zeigen 
var effectsDef = askUser();

// den Handler aufrufen, welcher das Ergebnis in eine Datei schreibt
writeResult(effectsDef);

// eine Schleife durch die Auswahl; 
for (var i=0; i<nFrames; i++) {
	curItem = curSel[i];
	handleGroupItems(curItem);
}

// die Funktion, welche eventuelle Gruppen behandelt
function handleGroupItems(curFrame) {
	curType = curFrame.constructor.name;
	if (curType == "Rectangle" || curType == "TextFrame" || curType == "Oval" || curType == "Polygon") {
		// eine eventuelle Eckenoption ausschalten
		if (appVers > 6) {
			curFrame.topLeftCornerOption     = CornerOptions.NONE;
			curFrame.topLeftCornerRadius     = "12pt";
			curFrame.bottomLeftCornerOption  = CornerOptions.NONE;
			curFrame.bottomLeftCornerRadius  = "12pt";
			curFrame.bottomRightCornerOption = CornerOptions.NONE;
			curFrame.bottomRightCornerRadius = "12pt";
			curFrame.topRightCornerOption    = CornerOptions.NONE;
			curFrame.topRightCornerRadius    = "12pt";
		}
		else if (appVers < 7 && appVers > 4) {
			if (curFrame.cornerOption != 1852796517) {
				curFrame.cornerOption = 1852796517;
			}
		}
		else if (appVers < 5) {
			if (curFrame.cornerEffect != 1852796517) {
				curFrame.cornerEffect = 1852796517;
			}
		}
		// der aktuelle Pfad des Rahmens
		curPath = curFrame.paths.item(0);
		if (curPath.pathType == 1668051812) {
			makeCorners(curFrame);
		}
		else {
			if (fCtr == 1) {
				alert ("Das ist kein geschlossener Pfad.", "Stop");
				resetAsBefore();
				exit();
			}
			else {
				cCtr++;
			}
		}
	}
	else if (curType == "Group") {
		var allFrames = curFrame.allPageItems;
		for (var k=0; k<allFrames.length; k++) {
			curFrame = allFrames[k];
			curType = curFrame.constructor.name;
			if (curType != "Group") {
				handleGroupItems(curFrame);
			}
		}
	}
}

// die Funktion zum Zurcksetzen der Aenderungen aufrufen
resetAsBefore();

// eventuelle Probleme melden
if (pCtr == 1) {
	alert ("Fr einen Rahmen sind die Werte zu gross.", "Ein Problem");
}
else if (pCtr > 1) {
	alert ("Fr " + pCtr + " Rahmen sind die Werte zu gross.", "Probleme");
}
if (cCtr == 1) {
	alert ("Ein Rahmen hat keinen geschlossenen Pfad.", "Ein Problem");
}
else if (cCtr > 1) {
	alert ("" + cCtr + " Rahmen haben keine geschlossenen Pfade.", "Probleme");
}
if (uCtr == 1) {
	alert ("Ein unbekanntes Problem hat das Abrunden verhindert.", "Klappte nicht");
}
else if (uCtr > 1) {
	alert ("" + uCtr + " unbekannte Probleme haben das Abrunden verhindert.", "Klappte nicht");
}


// -----------------------------------------------------------------------
// die Funktionen
// -----------------------------------------------------------------------

// die eingestellte Lineal-Einheit umwandeln
function unitsEnumToString(hM) {
	switch(hM) {
		case 2054188905 :
			return "in Punkten";
		case 2054187363 :
			return "in Picas";
		case 2053729891 :
			return "in Zoll";
		case 2053729892 :
			return "in Dezimalzoll";
		case 2053991795 :
			return "in Millimetern";
		case 2053336435 :
			return "in Zentimetern";
		case 2053335395 :
			return "in Ciceros";
		case 2051106676 :
			return "in Agaten";
		case 1131639917 :
			return "benutzerdefiniert";
		default :
			return "unbekannt";
	}
}

// der Handler, welcher die Informationen vorbereitet
function getPrefs() {
	var effectsDef = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/effects3.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			effectsDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return effectsDef;
}

// den Anwender auffordern, die Werte einzugeben
function askUser() {
	// Dialoge, welche eventuell im Speicher geblieben sind, lschen
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"EckenEffekte", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Die Radien (" + curUnit + ")"});
				staticTexts.add({staticLabel:" "});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							var topLeft = realEditboxes.add({editValue:topL, minimumValue:0, maximumValue:9999, minWidth:48});
							staticTexts.add({staticLabel:" ", minWidth:32});
							var topRght = realEditboxes.add({editValue:topR, minimumValue:0, maximumValue:9999, minWidth:48});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							var botLeft = realEditboxes.add({editValue:botL, minimumValue:0, maximumValue:9999, minWidth:48});
							staticTexts.add({staticLabel:" ", minWidth:32});
							var botRght = realEditboxes.add({editValue:botR, minimumValue:0, maximumValue:9999, minWidth:48});
						}
					}
				}
			}
			with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:8});
			var typeButtons = radiobuttonGroups.add();
			with (typeButtons) {
				radiobuttonControls.add({staticLabel:"abgerundet", checkedState:rType});
				radiobuttonControls.add({staticLabel:"nach innen gewlbt", checkedState:iType});
				radiobuttonControls.add({staticLabel:"abgeschrgt", checkedState:bType});
			}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var camberStraight = checkboxControls.add({staticLabel:"die Geraden ganz leicht wlben", checkedState:camb});
				}
			}
		}
	}
	
	// den Dialog anzeigen
	if (aDialog.show() == true) {
		// Ecke links oben
		topL = topLeft.editValue;
		// Ecke rechts oben
		topR = topRght.editValue;
		// Ecke links unten
		botL = botLeft.editValue;
		// Ecke rechts unten
		botR = botRght.editValue;
		// die Radiobuttons
		typeBtn = typeButtons.selectedButton;
		if (typeBtn == 0) {
			topLBtn = topRBtn = 0;
			botLBtn = botRBtn = 2;
		}
		else if (typeBtn == 1) {
			topLBtn = topRBtn = 2;
			botLBtn = botRBtn = 0;
		}
		else if (typeBtn == 2) {
			topLBtn = topRBtn = 1;
			botLBtn = botRBtn = 1;
		}
		// die Checkbox
		var camberStr = camberStraight.checkedState;
		camber = camberStr;
		// den Dialog aus dem Speicher entfernen
		aDialog.destroy();
		// das Ergebnis zum Speichern vorbereiten
		var effectsDef = topL + "\n" + topR + "\n" + botL + "\n" + botR + "\n" + typeBtn + "\n" + camber;
	}
	else {
		aDialog.destroy();
		resetAsBefore();
		exit();
	}
	return effectsDef;
}

// das Ergebnis in eine Datei schreiben
function writeResult(effectsDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/effects3.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(effectsDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// ---/---/---/---/---/---/---/---/---/---/---/---/
// die Hauptfunktion
function makeCorners(curFrame) {
	// prfen, ob mindestens ein Wert grsser als Null ist
	if ((topL+topR+botL+botR) == 0) {
		if (curPath.pathPoints.length == 4) {
			return;
		}
	}
	
	// eine eventuelle Sperrung aufheben
	unLock = unLockParent = false;
	if (curFrame.locked == true) {
		unLock = true;
		try {
			curFrame.locked = false;
		}
		catch (e) {
			unLockParent = true;
			actType = "Group";
			actFrame = curFrame.parent;
			while (actType == "Group") {
				actType = actFrame.constructor.name;
				if (actType == "Group") {
					topGroup = actFrame;
				}
				try {
					actFrame.locked = false;
				}
				catch (e) {
				}
				actFrame = actFrame.parent;
			}
		}
	}
	
	// den Drehwinkel speichern und auf Null setzen (falls notwendig)
	rA = curFrame.rotationAngle;
	sA = curFrame.shearAngle;
	if (sA != 0) {
		curFrame.shearAngle = 0;
	}
	if (rA != 0) {
		curFrame.rotationAngle = 0;
	}
	
	// die Bounds des Rahmens speichern
	gB = curFrame.geometricBounds;
	// Hhe und Breite des Rahmens speichern ...
	oH = Math.floor((((gB[2]-gB[0])*1000)+0.5))/1000;
	oW = Math.floor((((gB[3]-gB[1])*1000)+0.5))/1000;
	// ... und prfen
	if (oH < 1) {
		return;
	}
	else if (oW < 1) {
		return;
	}
	
	// Rahmen-Abmessungen und Radius vergleichen
	if ((topL+topR) > oW) {
		if (fCtr == 1) {
			alert ("Das Total der Radien \"oben links\" plus \"oben rechts\" ist zu gross.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((botL+botR) > oW) {
		if (fCtr == 1) {
			alert ("Das Total der Radien \"unten links\" plus \"unten rechts\" ist zu gross.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((topL+botL) > oH) {
		if (fCtr == 1) {
			alert ("Das Total der Radien \"oben links\" plus \"unten links\" ist zu gross.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	else if ((topR+botR) > oH) {
		if (fCtr == 1) {
			alert ("Das Total der Radien \"oben rechts\" plus \"unten rechts\" ist zu gross.", "Stop");
			resetRotation(curFrame);
			resetAsBefore();
			exit();
		}
		else {
			pCtr++;
			return;
		}
	}
	
	// den neuen Pfad vorbereiten
	newPath = new Array ();
	
	// die Radien ganz leicht verringern, wenn wlben verlangt ist
	if (camber) {
		if (!(topL+topR) == oW && !(botL+botR) == oW && !(topL+botL) == oH && !(topR+botR) == oH) {
			if (!(topL+topR) == oW && !(botL+botR) == oW) {
				if (!(topL+botL) == oH && !(topR+botR) == oH) {
					topL = topL*corrVal;
					topR = topR*corrVal;
					botR = botR*corrVal;
					botL = botL*corrVal;
				}
				else {
					if ((topL+topR) == oW) {
						botR = botR*corrVal;
						botL = botL*corrVal;
					}
					else if ((botL+botR) == oW) {
						topL = topL*corrVal;
						topR = topR*corrVal;
					}
					else if ((topL+botL) == oH) {
						topR = topR*corrVal;
						botR = botR*corrVal;
					}
					else if ((topR+botR) == oH) {
						topL = topL*corrVal;
						botL = botL*corrVal;
					}
				}
			}
		}
	}
	// die Ankerpositionen
	aT1   = gB[1]+topL;
	aT2   = gB[3]-topR;
	aR1   = gB[0]+topR;
	aR2   = gB[2]-botR;
	aB2   = gB[3]-botR;
	aB1   = gB[1]+botL;
	aL2   = gB[2]-botL;
	aL1   = gB[0]+topL;
	aT1b  = [aT1, gB[0]];
	aT2b  = [aT2, gB[0]];
	aR1b  = [gB[3], aR1];
	aR2b  = [gB[3], aR2];
	aB2b  = [aB2, gB[2]];
	aB1b  = [aB1, gB[2]];
	aL2b  = [gB[1], aL2];
	aL1b  = [gB[1], aL1];
	// die Griffpunkte-Offsets
	T1off = topL * 0.552284743254;
	T2off = topR * 0.552284743254;
	R1off = topR * 0.552284743254;
	R2off = botR * 0.552284743254;
	B2off = botR * 0.552284743254;
	B1off = botL * 0.552284743254;
	L2off = botL * 0.552284743254;
	L1off = topL * 0.552284743254;
	// die Korrekturwerte
	if (camber) {
		T1cor = topL/30;
		L1cor = topL/30;
		if (T1cor > L1cor) { TLcor = L1cor; } else { TLcor = T1cor; }
		T2cor = topR/30;
		R1cor = topR/30;
		if (T2cor > R1cor) { TRcor = R1cor; } else { TRcor = R1cor; }
		R2cor = botR/30;
		B2cor = botR/30;
		if (R2cor > B2cor) { BRcor = B2cor; } else { BRcor = R2cor; }
		B1cor = botL/30;
		L2cor = botL/30;
		if (B1cor > L2cor) { BLcor = L2cor; } else { BLcor = B1cor; }
	}
	else {
		TLcor = TRcor = BRcor = BLcor = 0;
	}
	
	// wenn das Ergebnis quadratisch ist ...
	if ((topL+topR) == oW && (botL+botR) == oW && (topL+botL) == oH && (topR+botR) == oH) {
		roundedBottom();
		roundedRight();
		roundedTop();
		roundedLeft();
	}
	else {
		// "oben links"  plus "oben rechts"  = Rahmenbreite
		// "unten links" plus "unten rechts" = Rahmenbreite
		if ((topL+topR) == oW && (botL+botR) == oW) {
			// der Ankerpunkt rechts unten /////////////
			anchorRight2();
			// der Ankerpunkt rechts oben /////////////
			anchorRight1();
			// die Rundung oben /////////////
			roundedTop();
			// der Ankerpunkt links oben /////////////
			anchorLeft1();
			// der Ankerpunkt links unten /////////////
			anchorLeft2();
			// die Rundung unten /////////////
			roundedBottom();
		}
		// "oben links" plus "oben rechts" = Rahmenbreite
		else if ((topL+topR) == oW) {
			// der Ankerpunkt rechts unten /////////////
			anchorRight2();
			// der Ankerpunkt rechts oben /////////////
			anchorRight1();
			// die Rundung oben /////////////
			roundedTop();
			// der Ankerpunkt links oben /////////////
			anchorLeft1();
			// die Ecke links unten /////////////
			cornerBottomLeft();
			// der Ankerpunkt unten rechts /////////////
			anchorBottom2();
		}
		// "unten links" plus "unten rechts = Rahmenbreite
		else if ((botL+botR) == oW) {
			// der Ankerpunkt rechts unten /////////////
			anchorRight2();
			// die Ecke rechts oben /////////////
			cornerTopRight();
			// die Ecke links oben /////////////
			cornerTopLeft();
			// der Ankerpunkt links unten /////////////
			anchorLeft2();
			// die Rundung unten /////////////
			roundedBottom();
		}
		// "oben links"  plus "unten links  = Rahmenhhe
		// "oben rechts" plus "unten rechts = Rahmenhhe
		else if ((topL+botL) == oH && (topR+botR) == oH) {
			// die Rundung rechts /////////////
			roundedRight();
			// der Ankerpunkt oben rechts /////////////
			anchorTop2();
			// der Ankerpunkt oben links /////////////
			anchorTop1();
			// die Rundung links /////////////
			roundedLeft();
			// der Ankerpunkt unten links /////////////
			anchorBottom1();
			// der Ankerpunkt unten rechts /////////////
			anchorBottom2();
		}
		// "oben links"  plus "unten links  = Rahmenhhe
		else if ((topL+botL) == oH) {
			// der Ankerpunkt rechts unten /////////////
			anchorRight2();
			// die Ecke rechts oben /////////////
			cornerTopRight();
			// der Ankerpunkt oben links /////////////
			anchorTop1();
			// die Rundung links /////////////
			roundedLeft();
			// der Ankerpunkt unten links /////////////
			anchorBottom1();
			// der Ankerpunkt unten rechts /////////////
			anchorBottom2();
		}
		// "oben rechts" plus "unten rechts" = Rahmenhhe
		else if ((topR+botR) == oH) {
			// die Rundung rechts /////////////
			roundedRight();
			// der Ankerpunkt oben rechts /////////////
			anchorTop2();
			// die Ecke links oben /////////////
			cornerTopLeft();
			// die Ecke links unten /////////////
			cornerBottomLeft();
			// der Ankerpunkt unten rechts /////////////
			anchorBottom2();
		}
		else {
			// der Ankerpunkt rechts unten /////////////
			anchorRight2();
			// die Ecke rechts oben /////////////
			cornerTopRight();
			// die Ecke links oben /////////////
			cornerTopLeft();
			// die Ecke links unten /////////////
			cornerBottomLeft();
			// der Ankerpunkt unten rechts /////////////
			anchorBottom2();
		}
	}
	
	// den neuen Pfad zuweisen
	try {
		curPath.entirePath = newPath;
	}
	catch (e) {
		if (fCtr == 1) {
			alert ("Ein unbekanntes Problem hat das Abrunden verhindert.", "Klappte nicht");
		}
		else {
			uCtr++;
		}
	}
	
	// Breite und Hhe wiederherstellen
	curFrame.geometricBounds = gB;
	
	// Dreh- und Neigungswinkel zurcksetzen (falls notwendig)
	if (rA != 0) {
		curFrame.rotationAngle = rA;
	}
	if (sA != 0) {
		curFrame.shearAngle = sA;
	}
	
	// die Sperrung wiederherstellen
	if (unLockParent == true) {
		try {
			topGroup.locked = true;
		}
		catch (e) {
		}
	}
	else if (unLock == true) {
		try {
			curFrame.locked = true;
		}
		catch (e) {
		}
	}
}


// ---*---*---*---*---*---*---*---*---*---*---*---*
// ----- die Effekt-Funktionen -------------------
// ---*---*---*---*---*---*---*---*---*---*---*---*

// der Ankerpunkt oben links /////////////
function anchorTop1() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber && ((aT2-aT1)>(T1off+T2off))) {
				hT1a = [aT1+T1off, gB[0]-TLcor];
				hT1c = [aT1-T1off, gB[0]+TLcor];
			}
			else {
				hT1a = [aT1, gB[0]];
				hT1c = [aT1-T1off, gB[0]];
			}
			newPath.push([hT1a, aT1b, hT1c]);
		}
		else if (topLBtn == 1) {
			newPath.push(aT1b);
		}
		else if (topLBtn == 2) {
			hT1a = [aT1, gB[0]];
			hT1c = [aT1, gB[0]+T1off];
			newPath.push([hT1a, aT1b, hT1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// der Ankerpunkt oben rechts /////////////
function anchorTop2() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber && ((aT2-aT1)>(T1off+T2off))) {
				hT2a = [aT2+T2off, gB[0]+TRcor];
				hT2c = [aT2-T2off, gB[0]-TRcor];
			}
			else {
				hT2a = [aT2+T2off, gB[0]];
				hT2c = [aT2, gB[0]];
			}
			newPath.push([hT2a, aT2b, hT2c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aT2b);
		}
		else if (topRBtn == 2) {
			hT2a = [aT2, gB[0]+T2off];
			hT2c = [aT2, gB[0]];
			newPath.push([hT2a, aT2b, hT2c]);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// der Ankerpunkt rechts oben /////////////
function anchorRight1() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber && ((aR2-aR1)>(R1off+R2off))) {
				hR1a = [gB[3]+TRcor, aR1+R1off];
				hR1c = [gB[3]-TRcor, aR1-R1off];
			}
			else {
				hR1a = [gB[3], aR1];
				hR1c = [gB[3], aR1-R1off];
			}
			newPath.push([hR1a, aR1b, hR1c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aR1b);
		}
		else if (topRBtn == 2) {
			hR1a = [gB[3], aR1];
			hR1c = [gB[3]-R1off, aR1];
			newPath.push([hR1a, aR1b, hR1c]);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// der Ankerpunkt rechts unten /////////////
function anchorRight2() {
	if (botR != 0) {
		if (botRBtn == 2) {
			if (camber && ((aR2-aR1)>(R1off+R2off))) {
				hR2a = [gB[3]-BRcor, aR2+R2off];
				hR2c = [gB[3]+BRcor, aR2-R2off];
			}
			else {
				hR2a = [gB[3], aR2+R2off];
				hR2c = [gB[3], aR2];
			}
			newPath.push([hR2a, aR2b, hR2c]);
		}
		else if (botRBtn == 0) {
			hR2a = [gB[3]-R2off, aR2];
			hR2c = [gB[3], aR2];
			newPath.push([hR2a, aR2b, hR2c]);
		}
		else if (botRBtn == 1) {
			newPath.push(aR2b);
		}
	}
	else {
		newPath.push([gB[3], gB[2]]);
	}
}

// der Ankerpunkt unten rechts /////////////
function anchorBottom2() {
	if (botR != 0) {
		if (botRBtn == 2) {
			if (camber && ((aB2-aB1)>(B1off+B2off))) {
				hB2a = [aB2-B2off, gB[2]+BRcor];
				hB2c = [aB2+B2off, gB[2]-BRcor];
			}
			else {
				hB2a = [aB2, gB[2]];
				hB2c = [aB2+B2off, gB[2]];
			}
			newPath.push([hB2a, aB2b, hB2c]);
		}
		else if (botRBtn == 0) {
			hB2a = [aB2, gB[2]];
			hB2c = [aB2, gB[2]-B2off];
			newPath.push([hB2a, aB2b, hB2c]);
		}
		else if (botRBtn == 1) {
			newPath.push(aB2b);
		}
	}
}

// der Ankerpunkt unten links /////////////
function anchorBottom1() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber && ((aB2-aB1)>(B1off+B2off))) {
				hB1a = [aB1-B1off, gB[2]-BLcor];
				hB1c = [aB1+B1off, gB[2]+BLcor];
			}
			else {
				hB1a = [aB1-B1off, gB[2]];
				hB1c = [aB1, gB[2]];
			}
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 0) {
			hB1a = [aB1, gB[2]-B1off];
			hB1c = [aB1, gB[2]];
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aB1b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// der Ankerpunkt links unten /////////////
function anchorLeft2() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber && ((aL2-aL1)>(L1off+L2off))) {
				hL2a = [gB[1]-TLcor, aL2-L2off];
				hL2c = [gB[1]+TLcor, aL2+L2off];
			}
			else {
				hL2a = [gB[1], aL2];
				hL2c = [gB[1], aL2+L2off];
			}
			newPath.push([hL2a, aL2b, hL2c]);
		}
		else if (botLBtn == 0) {
			hL2a = [gB[1], aL2];
			hL2c = [gB[1]+L2off, aL2];
			newPath.push([hL2a, aL2b, hL2c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aL2b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// der Ankerpunkt links oben /////////////
function anchorLeft1() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber && ((aL2-aL1)>(L1off+L2off))) {
				hL1a = [gB[1]+TLcor, aL1-L1off];
				hL1c = [gB[1]-TLcor, aL1+L1off];
			}
			else {
				hL1a = [gB[1], aL1-L1off];
				hL1c = [gB[1], aL1];
			}
			newPath.push([hL1a, aL1b, hL1c]);
		}
		else if (topLBtn == 1) {
			newPath.push(aL1b);
		}
		else if (topLBtn == 2) {
			hL1a = [gB[1]+L1off, aL1];
			hL1c = [gB[1], aL1];
			newPath.push([hL1a, aL1b, hL1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// die Ecke links oben /////////////
function cornerTopLeft() {
	if (topL != 0) {
		if (topLBtn == 0) {
			if (camber) {
				if ((aT2-aT1)>(T1off+T2off)) {
					hT1a = [aT1+T1off, gB[0]-TLcor];
					hT1c = [aT1-T1off, gB[0]+TLcor];
				}
				else {
					hT1a = [aT1, gB[0]];
					hT1c = [aT1-T1off, gB[0]];
				}
				newPath.push([hT1a, aT1b, hT1c]);
				if ((aL2-aL1)>(L1off+L2off)) {
					hL1a = [gB[1]+TLcor, aL1-L1off];
					hL1c = [gB[1]-TLcor, aL1+L1off];
				}
				else {
					hL1a = [gB[1], aL1-L1off];
					hL1c = [gB[1], aL1];
				}
				newPath.push([hL1a, aL1b, hL1c]);
			}
			else {
				hT1a = [aT1, gB[0]];
				hT1c = [aT1-T1off, gB[0]];
				newPath.push([hT1a, aT1b, hT1c]);
				hL1a = [gB[1], aL1-L1off];
				hL1c = [gB[1], aL1];
				newPath.push([hL1a, aL1b, hL1c]);
			}
		}
		else if (topLBtn == 1) {
			newPath.push(aT1b);
			newPath.push(aL1b);
		}
		else if (topLBtn == 2) {
			hT1a = [aT1, gB[0]];
			hT1c = [aT1, gB[0]+T1off];
			newPath.push([hT1a, aT1b, hT1c]);
			hL1a = [gB[1]+L1off, aL1];
			hL1c = [gB[1], aL1];
			newPath.push([hL1a, aL1b, hL1c]);
		}
	}
	else {
		newPath.push([gB[1], gB[0]]);
	}
}

// die Ecke rechts oben /////////////
function cornerTopRight() {
	if (topR != 0) {
		if (topRBtn == 0) {
			if (camber) {
				if ((aR2-aR1)>(R1off+R2off)) {
					hR1a = [gB[3]+TRcor, aR1+R1off];
					hR1c = [gB[3]-TRcor, aR1-R1off];
				}
				else {
					hR1a = [gB[3], aR1];
					hR1c = [gB[3], aR1-R1off];
				}
				newPath.push([hR1a, aR1b, hR1c]);
				if ((aT2-aT1)>(T1off+T2off)) {
					hT2a = [aT2+T2off, gB[0]+TRcor];
					hT2c = [aT2-T2off, gB[0]-TRcor];
				}
				else {
					hT2a = [aT2+T2off, gB[0]];
					hT2c = [aT2, gB[0]];
				}
				newPath.push([hT2a, aT2b, hT2c]);
			}
			else {
				hR1a = [gB[3], aR1];
				hR1c = [gB[3], aR1-R1off];
				newPath.push([hR1a, aR1b, hR1c]);
				hT2a = [aT2+T2off, gB[0]];
				hT2c = [aT2, gB[0]];
				newPath.push([hT2a, aT2b, hT2c]);
			}
		}
		else if (topRBtn == 2) {
			hR1a = [gB[3], aR1];
			hR1c = [gB[3]-R1off, aR1];
			newPath.push([hR1a, aR1b, hR1c]);
			hT2a = [aT2, gB[0]+T2off];
			hT2c = [aT2, gB[0]];
			newPath.push([hT2a, aT2b, hT2c]);
		}
		else if (topRBtn == 1) {
			newPath.push(aR1b);
			newPath.push(aT2b);
		}
	}
	else {
		newPath.push([gB[3], gB[0]]);
	}
}

// die Ecke links unten /////////////
function cornerBottomLeft() {
	if (botL != 0) {
		if (botLBtn == 2) {
			if (camber) {
				if ((aL2-aL1)>(L1off+L2off)) {
					hL2a = [gB[1]-BLcor, aL2-L2off];
					hL2c = [gB[1]+BLcor, aL2+L2off];
				}
				else {
					hL2a = [gB[1], aL2];
					hL2c = [gB[1], aL2+L2off];
				}				
				newPath.push([hL2a, aL2b, hL2c]);
				if ((aB2-aB1)>(B1off+B2off)) {
					hB1a = [aB1-B1off, gB[2]-BLcor];
					hB1c = [aB1+B1off, gB[2]+BLcor];
				}
				else {
					hB1a = [aB1-B1off, gB[2]];
					hB1c = [aB1, gB[2]];
				}
				newPath.push([hB1a, aB1b, hB1c]);				
			}
			else {
				hL2a = [gB[1], aL2];
				hL2c = [gB[1], aL2+L2off];
				newPath.push([hL2a, aL2b, hL2c]);
				hB1a = [aB1-B1off, gB[2]];
				hB1c = [aB1, gB[2]];
				newPath.push([hB1a, aB1b, hB1c]);
			}
		}
		else if (botLBtn == 0) {
			hL2a = [gB[1], aL2];
			hL2c = [gB[1]+L2off, aL2];
			newPath.push([hL2a, aL2b, hL2c]);
			hB1a = [aB1, gB[2]-B1off];
			hB1c = [aB1, gB[2]];
			newPath.push([hB1a, aB1b, hB1c]);
		}
		else if (botLBtn == 1) {
			newPath.push(aL2b);
			newPath.push(aB1b);
		}
	}
	else {
		newPath.push([gB[1], gB[2]]);
	}
}

// die Rundung rechts /////////////
function roundedRight() {
	if (botRBtn == 2 && topRBtn == 0) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 2 && topRBtn == 1) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = aR1b;
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 2 && topRBtn == 2) {
		hR1a = [gB[3], aR1+R2off];
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 1 && topRBtn == 0) {
		hR1a = aR1b;
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 1 && topRBtn == 1) {
		newPath.push(aR1b);
	}
	else if (botRBtn == 1 && topRBtn == 2) {
		hR1a = aR1b;
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 0) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = [gB[3], aR1-R1off];
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 1) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = aR1b;
		newPath.push([hR1a, aR1b, hR1c]);
	}
	else if (botRBtn == 0 && topRBtn == 2) {
		hR1a = [gB[3]-R2off, aR1];
		hR1c = [gB[3]-R1off, aR1];
		newPath.push([hR1a, aR1b, hR1c]);
	}
}

// die Rundung oben /////////////
function roundedTop() {
	if (topLBtn == 0 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = [aT1-T1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 0 && topRBtn == 1) {
		hT1a = aT1b;
		hT1c = [aT1-T1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 0 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+T2off];
		hT1c = [aT1-L1off, gB[0]];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 1 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = aT1b;
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 1 && topRBtn == 1) {
		newPath.push(aT1b);
	}
	else if (topLBtn == 1 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+T2off];
		hT1c = aT1b;
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 0) {
		hT1a = [aT1+T2off, gB[0]];
		hT1c = [aT1, gB[0]+T1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 1) {
		hT1a = aT1b;
		hT1c = [aT1, gB[0]+T1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
	else if (topLBtn == 2 && topRBtn == 2) {
		hT1a = [aT1, gB[0]+R1off];
		hT1c = [aT1, gB[0]+L1off];
		newPath.push([hT1a, aT1b, hT1c]);
	}
}

// die Rundung links /////////////
function roundedLeft() {
	if (topLBtn == 0 && botLBtn == 2) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 0 && botLBtn == 1) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = aL1b;
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 0 && botLBtn == 0) {
		hL1a = [gB[1], aL1-L1off];
		hL1c = [gB[1]+L2off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 1 && botLBtn == 2) {
		hL1a = aL1b;
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 1 && botLBtn == 1) {
		newPath.push(aL1b);
	}
	else if (topLBtn == 1 && botLBtn == 0) {
		hL1a = aL1b;
		hL1c = [gB[1]+L1off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 2) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = [gB[1], aL1+L2off];
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 1) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = aL1b;
		newPath.push([hL1a, aL1b, hL1c]);
	}
	else if (topLBtn == 2 && botLBtn == 0) {
		hL1a = [gB[1]+L1off, aL1];
		hL1c = [gB[1]+L2off, aL1];
		newPath.push([hL1a, aL1b, hL1c]);
	}
}

// die Rundung unten /////////////
function roundedBottom() {
	if (botLBtn == 2 && botRBtn == 2) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 2 && botRBtn == 1) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = aB1b;
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 2 && botRBtn == 0) {
		hB1a = [aB1-B1off, gB[2]];
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 1 && botRBtn == 2) {
		hB1a = aB1b;
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 1 && botRBtn == 1) {
		newPath.push(aB1b);
	}
	else if (botLBtn == 1 && botRBtn == 0) {
		hB1a = aB1b;
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 2) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = [aB1+B2off, gB[2]];
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 1) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = aB1b;
		newPath.push([hB1a, aB1b, hB1c]);
	}
	else if (botLBtn == 0 && botRBtn == 0) {
		hB1a = [aB1, gB[2]-B1off];
		hB1c = [aB1, gB[2]-B2off];
		newPath.push([hB1a, aB1b, hB1c]);
	}
}

// ---*---*---*---*---*---*---*---*---*---*---*---*
// die Aenderungen zurcksetzen (falls notwendig)
function resetRotation(curFrame) {
	// Dreh- und Neigungswinkel zurcksetzen
	if (rA != 0) {
		curFrame.rotationAngle = rA;
	}
	if (sA != 0) {
		curFrame.shearAngle = sA;
	}
}

function resetAsBefore() {
	// die vertikale Masseinheit zurcksetzen
	if (vM != hM) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	// auf unbekannte Einheit zurcksetzen
	if (curUnit == "unbekannt") {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}